Xfce Foundation Classes
Main Page | Index | Namespace List | Alphabetical List | Class List | File List

# Xfc::Atk::Object Class Reference

An AtkObject C++ wrapper class. More...

`#include <xfc/atk/object.hh>`

Inheritance diagram for Xfc::Atk::Object:

List of all members.

## Signal Prototypes

- const ChildrenChangedSignalType children_changed_signal
    Children changed signal (see signal_children_changed()).
- const FocusEventSignalType focus_event_signal
    Focus event signal (see signal_focus_event()).
- const PropertyChangeSignalType property_change_signal
    Property change signal (see signal_property_change()).
- const StateChangeSignalType state_change_signal
    State change signal (see signal_state_change()).
- const VisibleDataChangedSignalType visible_data_changed_signal
    Visible data changed signal (see signal_visible_data_changed()).
- const ActiveDescendantChangedSignalType active_descendant_changed_signal
    Active descendant changed signal (see signal_active_descendant_changed()).

## Public Member Functions

Constructors

- virtual ~Object ()
    Destructor.

Accessors

- AtkObject * atk_object () const
    Get a pointer to the AtkObject structure.
- operator AtkObject * () const
    Conversion operator; safely converts an Object to an AtkObject pointer.
- String get_name () const
    Gets the accessible name of the object.
- String get_description () const
    Gets the accessible description of the object.
- Object * get_parent () const
    Gets the accessible parent of the object.
- int get_n_accessible_children () const
    Gets the number of accessible children of the object.
- Object * ref_accessible_child (int index) const
    Gets a pointer to the specified accessible child of the object.
- RelationSet * ref_relation_set () const
    Gets the RelationSet associated with the object.
- Role get_role () const
    Gets the role of the accessible object.
- Pointer< StateSet > ref_state_set () const
    Gets a reference to the StateSet of the accessible object.
- int get_index_in_parent () const
    Gets the zero-based index of this accessible object in its parent.

Methods

- void set_name (const String &name)
    Sets the accessible name of the object.
- void set_description (const String &description)
    Sets the accessible description of the object.
- void set_parent (Object &parent)
    Sets the accessible parent of the object.
- void set_role (Role role)
    Sets the role of the accessible object.
- void notify_state_change (State state, bool value)
    Emits a "state_change" signal for the specified state.
- bool add_relationship (RelationType relationship, const Object &target)
    Adds a relationship of the specified type to the specified target.
- bool remove_relationship (RelationType relationship, const Object &target)
    Removes a relationship of the specified type from the specified target.

Signal Proxies

- const ChildrenChangedSignalProxy signal_children_changed ()
    Connect to the children_changed_signal; emitted when the number of children of the object changes.
- const FocusEventSignalProxy signal_focus_event ()
    Connect to the focus_event_signal; emitted when there is a focus event for an object.
- const PropertyChangeSignalProxy signal_property_change ()
    Connect to the property_change_signal; emitted when the value of an object property changes.
- const StateChangeSignalProxy signal_state_change ()
    Connect to the state_change_signal; emitted when the state of an object changes.
- const VisibleDataChangedSignalProxy signal_visible_data_changed ()
    Connect to the visible_data_changed_signal; emitted when there is a change in the visible data for an object.
- const ActiveDescendantChangedSignalProxy signal_active_descendant_changed ()
    Connect to the active_descendant_changed_signal; emitted when there is a change in the 'active' child or children of the object (for instance, when the interior focus changes in a table or list).

## Protected Member Functions

Constructors

- Object (AtkObject *object, bool owns_reference=true)
    Construct a new Object from an existing AtkObject.

## Detailed Description

An AtkObject C++ wrapper class.

Atk::Object is the primary class for accessibility support via the Accessibility ToolKit (ATK). Objects which are instances of Atk::Object (or instances of Atk::Object-derived types) are queried for properties which relate basic (and generic) properties of a UI component such as name and description. Instances of Atk::Object may also be queried as to whether they implement other ATK interfaces (e.g. Action, Component, etc.), as appropriate to the role which a given UI component plays in a user interface.

All UI components in an application which provide useful information or services to the user must provide corresponding Atk::Object instances on request (in GTK+, for instance, usually on a call to Gtk::Widget::get_accessible()), either via ATK support built into the toolkit for the widget class or ancestor class, or in the case of custom widgets, if the inherited Atk::Object implementation is insufficient, via instances of a new Atk::Object subclass.

## Constructor & Destructor Documentation

Xfc::Atk::Object::Object | ( | AtkObject * | object,
|  | bool | owns_reference = `true`
| ) | `[explicit, protected]`

Construct a new Object from an existing AtkObject.

Parameters:

  | object | A pointer to a AtkObject.
  | owns_reference | Set false if the initial reference count is floating, set true if it's not.

The object can be a newly created AtkObject or an existing AtkObject. (see G::Object::Object).

## Member Function Documentation

bool Xfc::Atk::Object::add_relationship | ( | RelationType | relationship,
|  | const Object & | target
| ) |

Adds a relationship of the specified type to the specified target.

Parameters:

  | relationship | The RelationType of the relation.
  | target | The Atk::Object which is to be the target of the relation.

Returns:
  true if the relationship was added.

String Xfc::Atk::Object::get_description | ( |  | ) | const

Gets the accessible description of the object.

Returns:
  A character string representing the accessible description of the object.

int Xfc::Atk::Object::get_index_in_parent | ( |  | ) | const

Gets the zero-based index of this accessible object in its parent.

Returns:
  An integer which is the index of the accessible object in its parent, or -1 if the accessible does not have an accessible parent.

int Xfc::Atk::Object::get_n_accessible_children | ( |  | ) | const

Gets the number of accessible children of the object.

Returns:
  An integer representing the number of accessible children of the object.

String Xfc::Atk::Object::get_name | ( |  | ) | const

Gets the accessible name of the object.

Returns:
  A character string representing the accessible name of the object.

Object* Xfc::Atk::Object::get_parent | ( |  | ) | const

Gets the accessible parent of the object.

Returns:
  An Atk::Object representing the accessible parent of the object.

Role Xfc::Atk::Object::get_role | ( |  | ) | const

Gets the role of the accessible object.

Returns:
  A Role which is the role of the accessible object.

void Xfc::Atk::Object::notify_state_change | ( | State | state,
|  | bool | value
| ) |

Emits a "state_change" signal for the specified state.

Parameters:

  | state | A State whose state is changed.
  | value | Indicates whether the state is being set on or off.

Object* Xfc::Atk::Object::ref_accessible_child | ( | int | index | ) | const

Gets a pointer to the specified accessible child of the object.

Parameters:

  | index | An integer representing the position of the child, starting from 0.

Returns:
  An Atk::Object representing the specified accessible child of the object.

The accessible children are zero-based so the first accessible child is at index 0, the second at index 1 and so on.

RelationSet* Xfc::Atk::Object::ref_relation_set | ( |  | ) | const

Gets the RelationSet associated with the object.

Returns:
  A RelationSet representing the relation set of the object.

Pointer<StateSet> Xfc::Atk::Object::ref_state_set | ( |  | ) | const

Gets a reference to the StateSet of the accessible object.

Returns:
  A smart pointer to a StateSet which is the state set of the accessible object.

bool Xfc::Atk::Object::remove_relationship | ( | RelationType | relationship,
|  | const Object & | target
| ) |

Removes a relationship of the specified type from the specified target.

Parameters:

  | relationship | The RelationType of the relation.
  | target | The Atk::Object which is the target of the relation to be removed.

Returns:
  true if the relationship was removed.

void Xfc::Atk::Object::set_description | ( | const String & | description | ) |

Sets the accessible description of the object.

Parameters:

  | description | A character string to be set as the accessible description.

void Xfc::Atk::Object::set_name | ( | const String & | name | ) |

Sets the accessible name of the object.

Parameters:

  | name | A character string to be set as the accessible name.

void Xfc::Atk::Object::set_parent | ( | Object & | parent | ) |

Sets the accessible parent of the object.

Parameters:

  | parent | An Atk::Object to be set as the accessible parent.

void Xfc::Atk::Object::set_role | ( | Role | role | ) |

Sets the role of the accessible object.

Parameters:

  | role | A Role to be set as the role.

const ActiveDescendantChangedSignalProxy Xfc::Atk::Object::signal_active_descendant_changed | ( |  | ) |

| Connect to the active_descendant_changed_signal; emitted when there is a change in the 'active' child or children of the object (for instance, when the interior focus changes in a table or list). This signal should be emitted by objects whose state includes Atk::STATE_MANAGES_DESCENDANTS.

## Member Data Documentation

const ActiveDescendantChangedSignalType Xfc::Atk::Object::active_descendant_changed_signal `[static, protected]`

Active descendant changed signal (see signal_active_descendant_changed()).

Calls a slot with the signature:

                 void function(void **child);
                 // child: The newly focused object.

const ChildrenChangedSignalType Xfc::Atk::Object::children_changed_signal `[static, protected]`

Children changed signal (see signal_children_changed()).

Calls a slot with the signature:

                 void function(unsigned int change_index, void *changed_child);
                 // change_index: The index of the added or removed child.
                 // changed_child: The child which was added or removed.

const FocusEventSignalType Xfc::Atk::Object::focus_event_signal `[static, protected]`

Focus event signal (see signal_focus_event()).

Calls a slot with the signature:

                 void function(bool focus_in);
                 // focus_in: Indicates whether or not the focus event is is or out.

const PropertyChangeSignalType Xfc::Atk::Object::property_change_signal `[static, protected]`

Property change signal (see signal_property_change()).

Calls a slot with the signature:

                 void function(AtkPropertyValues *values);
                 // values: The new value of the property which changed.

const StateChangeSignalType Xfc::Atk::Object::state_change_signal `[static, protected]`

State change signal (see signal_state_change()).

Calls a slot with the signature:

                 void function(const String& name, bool state_set);
                 // name: The name of the state which has changed.
                 // state_set: Indicates whether the state has been set or unset.

const VisibleDataChangedSignalType Xfc::Atk::Object::visible_data_changed_signal `[static, protected]`

Visible data changed signal (see signal_visible_data_changed()).

Calls a slot with the signature:

                 void function();

The documentation for this class was generated from the following file:

- libXFCui/xfc/atk/object.hh

Xfce Foundation Classes

Copyright © 2004-2005 The XFC Development Team | XFC 4.3